' 
' Copyright (c) 2004-2011 DNN-Europe, http://www.dnn-europe.net
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this 
' software and associated documentation files (the "Software"), to deal in the Software 
' without restriction, including without limitation the rights to use, copy, modify, merge, 
' publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons 
' to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or 
' substantial portions of the Software.

' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
' PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
' FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
' ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
' 

Namespace Entities.Objects

 Partial Public Class ObjectInfo
  Private _module As ModuleInfo

#Region " Public Properties "

  Public Property [Module]() As ModuleInfo
   Get
    If _module Is Nothing Then
     _module = New ModuleInfo(ObjectId)
    End If
    Return _module
   End Get
   Set(ByVal value As ModuleInfo)
    _module = value
   End Set
  End Property

  Public ReadOnly Property IsCore As Boolean
   Get
    Return CBool(ObjectName = Globals.glbCoreName)
   End Get
  End Property

#End Region

#Region " Public Methods "

  Public Function GetParents() As List(Of ObjectInfo)
   Return Packages.PackagesController.GetParentObjects(ObjectId, Version)
  End Function

#End Region

 End Class

End Namespace
